import { Value } from './Value';
import type { ResolveType } from '../json-type';
import type * as classes from '../json-type/type';
import type * as ts from '../json-type/typescript/types';
type UnObjectType<T> = T extends classes.ObjectType<infer U> ? U : never;
type UnObjectFieldTypeVal<T> = T extends classes.ObjectFieldType<any, infer U> ? U : never;
export declare class ObjectValue<T extends classes.ObjectType<any>> extends Value<T> {
    field<F extends classes.ObjectFieldType<any, any>>(field: F, data: ResolveType<UnObjectFieldTypeVal<F>>): ObjectValue<classes.ObjectType<[...UnObjectType<T>, F]>>;
    prop<K extends string, V extends classes.Type>(key: K, type: V, data: ResolveType<V>): ObjectValue<classes.ObjectType<[...UnObjectType<T>, classes.ObjectFieldType<K, V>]>>;
    merge<O extends ObjectValue<any>>(obj: O): ObjectValue<classes.ObjectType<[...UnObjectType<T>, ...UnObjectType<O['type']>]>>;
    toTypeScriptAst(): ts.TsTypeLiteral;
    toTypeScriptModuleAst(): ts.TsModuleDeclaration;
    toTypeScript(): string;
}
export {};
