import { Value as V } from '../../../json-type-value/Value';
export class RpcValue extends V {
    data;
    type;
    constructor(data, type) {
        super(type, data);
        this.data = data;
        this.type = type;
    }
    encode(codec) {
        const value = this.data;
        const type = this.type;
        if (value === undefined)
            return;
        const encoder = codec.encoder;
        if (!type)
            encoder.writeAny(value);
        else
            type.encoder(codec.format)(value, encoder);
    }
}
